/* *****************************************************************************
 Propiedad Intelectual
 Nombre:	Rafael Alberto Moreno Parra
 C.C.:		16.832.929 Jdi/Valle
 
 Programa: Applet Java de graficacin lineal

 Descripcion:	Este programa muestra una caracteristica popular en el ambiente y
                que es ritmico. Se simula este ritmo generando expresiones aleatorias
				pero que se multiplican con una expresion sinusoidal.

 Fecha:			Febrero 21 de 1999

****************************************************************************** */
import java.applet.*;
import java.awt.*;
import java.util.*;
import EvalExpr; // Evaluador de expresiones
import frmAlifeSim5; //Cuadro de dilogo
import cMutacion; // Para generar expresiones F(x) aleatorias

//Applet
public class EvolSim5 extends Applet implements Runnable
{
	//Trabajar con hilos
	private Thread	 m_thRunner = null;

	//Variables globales
	String m_sSerieNum = new String();  //El ambiente en cadena
	
	//Cuadro de dialogo
	frmAlifeSim5 m_frmDlg5;

	//Mutacion
	cMutacion objMutacion;

	//Contador de #intentos o seres generados
	int m_iContIntento;

	//Probabilidades
	int m_iProbX, m_iProbP, m_iProbN;


	public EvolSim5()
	{
		// TODO: Add constructor code here
	}

	public String getAppletInfo()
	{
		return "Name: EvolSim5\r\n" +
		       "Author: Rafael Alberto Moreno Parra\r\n" +
		       "Created with Microsoft Visual J++ Version 1.1\r\n" +
		       "\r\n" +
		       "A-Life: Vida Artificial\r\n" +
		       "Simulacion V: Simula ambientes ciclicos" +
		       "\r\n" +
		       "\r\n" +
		       "\r\n" +
		       "";
	}


	public void init()
	{
    	int iCont;
		String sAcum="";
		
		resize(640, 240);

		// Llama el cuadro de dialogo con valores por defecto
		m_frmDlg5 = new frmAlifeSim5(this);
		m_frmDlg5.CreateControls();

		//Mutacion
		objMutacion = new cMutacion();

		IniciarValores();
	}

	public void destroy()
	{
		// TODO: Place applet cleanup code here
	}

	public void paint(Graphics g)
	{
	}

	public void start()
	{
		if (m_thRunner == null)
		{
			m_thRunner = new Thread(this);
			m_thRunner.start();
		}
	}
	
	public void stop()
	{
		if (m_thRunner != null)
		{
			m_thRunner.stop();
			m_thRunner=null;
		}	

	}

	public void run()
	{
		EvalExpr objEvalua01 = new EvalExpr();
		EvalExpr objEvalua02 = new EvalExpr();
		String sEcuacion01, sEcuacion02;
		String sSerie01, sSerie02;

		double fValX=0, fValY=0, PI=3.1415926537, dResult;
		int iCiclo;


		while(true)
		{
			//Crea la expresion sin(y) * F(x)
			objMutacion.vCrearExpresion(15, m_iProbX, m_iProbP, m_iProbN);
			sEcuacion01= "sin(y)*(" + objMutacion.sAcum + ")";
			m_frmDlg5.txtExpr01.setText(sEcuacion01);
		
			dResult = objEvalua01.dCapturaecuacion(sEcuacion01, 0, 0);
			for (iCiclo=0; iCiclo<=50; iCiclo++)
				for (fValY=0; fValY<=2*PI; fValY+=PI/8)
				{
					sSerie01 = "";
					for (fValX=0; fValX<=6; fValX++)
					{
						dResult = objEvalua01.CicloEvalua(fValX, fValY);
						sSerie01 += String.valueOf((float)dResult) + ", ";
					}
					m_frmDlg5.txtSerie01.setText(sSerie01);
					System.out.println(sSerie01);
				}
					

			//Crea la expresion cos(y) * F(x)
			objMutacion.vCrearExpresion(15, m_iProbX, m_iProbP, m_iProbN);
			sEcuacion02= "cos(y)*(" + objMutacion.sAcum + ")";
			m_frmDlg5.txtExpr02.setText(sEcuacion02);

			dResult = objEvalua02.dCapturaecuacion(sEcuacion02, 0, 0);
			for (iCiclo=0; iCiclo<=50; iCiclo++)
				for (fValY=0; fValY<=2*PI; fValY+=PI/8)
				{
					sSerie02="";
					for (fValX=0; fValX<=6; fValX++)
					{
						dResult = objEvalua02.CicloEvalua(fValX, fValY);
						sSerie02 += String.valueOf((float)dResult) + ", ";
					}
					m_frmDlg5.txtSerie02.setText(sSerie02);
					System.out.println(sSerie02);
				}
		}
	}

	// Manejador de eventos
    public boolean handleEvent( Event e )
    {
        boolean bReturn = false;

        if (e.target == m_frmDlg5.cmdOK)
		{
            bReturn = routeEvent_cmdOK(e);
			start();
		}

		if (e.target == m_frmDlg5.cmdStop)
			stop();
 
		if (bReturn == true)
            return true;
        else
            return super.handleEvent(e);
    }

	
	// Este es el evento de dar click sobre el boton
	private boolean routeEvent_cmdOK(Event e)
    {
        boolean bReturn = false;
		int iCont;
		String sAcum="";
		
        if (e.id == Event.ACTION_EVENT)
			IniciarValores();
	
       return bReturn;
	}

	void IniciarValores()
	{
		//Probabilidades de creacion de expresiones
		m_iProbX = 40;
		m_iProbP = 20;
		m_iProbN = 40;

		//Contador de Intentos
		m_iContIntento = 0;
	}

}
